-- Author      : Apoco
-- Create Date : 6/11/2008 7:40:54 PM
-- Credits: Hunter's Mark Mod by Zarnivoop

if not RBM or select(2, UnitClass("player")) ~= "HUNTER" then return end
local module = RBM:NewPlugin("Hunters Mark")

local L = module:GetTranslations()
local huntersmarkName, multiName, arcaneName, steadyName, aimedName
local marksLst = {}
local lastGUID
module:RegisterTranslations("enUS", -- translation automatically generated
	"Hunter's Mark", true,
	"Hunter's Mark Strength Bar", true,
	"Alert when maxed", true,
	"Show Bar", true,
	"Hunter'sMarkLabel", "HM Strength",
	"Hunters Mark Is Maxed!", true
)

module:RegisterTranslations("koKR",
	"Hunter's Mark", "사냥꾼의 징표",
	"Hunter's Mark Strength Bar", "사냥꾼의 징표 증가 바",
	"Alert when maxed", "최대일 경우 경고",
	"Show Bar", "바 표시",
	"Hunter'sMarkLabel", "사냥꾼의 징표 증가",
	"Hunters Mark Is Maxed!", "사냥꾼의 징표 증가 최대!"
)

function module:OnInitialize()
	self:SetDefaultEnabledState(false)
	self:RegisterCategory(L["Hunter's Mark"], L["Hunter's Mark Strength Bar"], .2, .9, .6)
	self:RegisterToggles(L["Alert when maxed"], true,
						 L["Show Bar"], true)
end

function module:OnEnable()
	huntersmarkName = GetSpellInfo(14325)
	multiName = GetSpellInfo(27021)
	arcaneName = GetSpellInfo(27019)
	steadyName = GetSpellInfo(34120)
	aimedName = GetSpellInfo(27065)
	for i in pairs(marksLst) do
		marksLst[i] = nil
	end
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
end

local eventLst = { ["SPELL_DAMAGE"] = true, ["RANGE_DAMAGE"] = true, ["SPELL_CAST_SUCCESS"] = true, ["SPELL_AURA_REMOVED"] = true, ["UNIT_DIED"] = true }
function module:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, _, _, _, destGUID, destName, _, spellFlag, spellName)
	if not eventLst[event] then return end
	if event == "SPELL_DAMAGE" then
		if spellName == multiName or spellName == arcaneName or spellName == aimedName or spellName == steadyName then
			self:AddToStrength(destGUID, destName)
		end
	
	elseif event == "RANGE_DAMAGE" and spellFlag == 75 then
		self:AddToStrength(destGUID, destName)

	elseif event == "SPELL_CAST_SUCCESS" and spellName == huntersmarkName then
		if not marksLst[destGUID] then
			marksLst[destGUID] = 0
			if UnitGUID("target") == destGUID then
				lastGUID = destGUID
				if self:CheckToggle(L["Show Bar"]) then
					self:LocalCountBar(self:CreateLabel(self:TrimString(destName), L["Hunter'sMarkLabel"]), L["Hunter's Mark"], 30, 0, 14325)
				end
			end
		end
	
	elseif event == "SPELL_AURA_REMOVED" and spellName == huntersmarkName then
		marksLst[destGUID] = nil
		if self:IsBarActive(self:CreateLabel(self:TrimString(destName), L["Hunter'sMarkLabel"])) then
			self:CancelBar(self:CreateLabel(self:TrimString(destName), L["Hunter'sMarkLabel"]))
		end
	
	elseif event == "UNIT_DIED" and marksLst[destGUID] then
		self:CancelBar(self:CreateLabel(self:TrimString(destName), L["Hunter'sMarkLabel"]))
		marksLst[destGUID] = nil
	end
end

function module:PLAYER_TARGET_CHANGED()
	if UnitGUID("target") ~= lastGUID then
		self:CancelBars()
	end
	lastGUID = UnitGUID("target")
	if marksLst[lastGUID] then
		local label = self:CreateLabel(self:TrimString(UnitName("target")), L["Hunter'sMarkLabel"])
		if self:CheckToggle(L["Show Bar"]) then
			self:LocalCountBar(label, L["Hunter's Mark"], 30, 0, 14325)
			self:SetBarCount(label, marksLst[lastGUID], false)
		end
		local i = 1
		local remove = true
		while UnitDebuff("target", i) do
			local name = UnitDebuff("target", i)
			if name == huntersmarkName then
				remove = false
				break
			end
			i = i + 1
		end
		if remove then
			marksLst[lastGUID] = nil
			self:CancelBar(label)
		end
	end
end

function module:AddToStrength(guid, name)
	if marksLst[guid] then
		if marksLst[guid] < 29 then
			marksLst[guid] = marksLst[guid] + 1
			if self:CheckToggle(L["Show Bar"]) then
				self:IncreaseBarCount(self:CreateLabel(self:TrimString(name), L["Hunter'sMarkLabel"]))
			end
			
		elseif marksLst[guid] == 29 then
			marksLst[guid] = marksLst[guid] + 1
			if self:CheckToggle(L["Show Bar"]) then
				self:IncreaseBarCount(self:CreateLabel(self:TrimString(name), L["Hunter'sMarkLabel"]))
			end
			if self:CheckToggle(L["Alert when maxed"]) then
				self:Alert("High", L["Hunters Mark Is Maxed!"])
			end
		end
	end
end